Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.math.analysis
Class PolynomialSplineFunction

    java.lang.Object
      org.apache.commons.math.analysis.PolynomialSplineFunction

All Implemented Interfaces:
  Serializable, UnivariateRealFunction

public class PolynomialSplineFunction
extends Object
implements UnivariateRealFunction, Serializable

Represents a polynomial spline function.

A polynomial spline function consists of a set of interpolating polynomials and an ascending array of domain knot points, determining the intervals over which the spline function is defined by the constituent polynomials. The polynomials are assumed to have been computed to match the values of another function at the knot points. The value consistency constraints are not currently enforced by `PolynomialSplineFunction` itself, but are assumed to hold among the polynomials and knot points passed to the constructor.

N.B.: The polynomials in the `polynomials` property must be centered on the knot points to compute the spline function values. See below.

The domain of the polynomial spline function is `[smallest knot, largest knot)`. Attempts to evaluate the function at values outside of this range generate IllegalArgumentExceptions.

The value of the polynomial spline function for an argument `x` is computed as follows:

1. The knot array is searched to find the segment to which `x` belongs. If `x` is less than the smallest knot point or greater than or equal to the largest one, an `IllegalArgumentException` is thrown.
2. Let `j` be the index of the largest knot point that is less than or equal to `x`. The value returned is
   `polynomials[j](x - knot[j])`

Version:
  $Revision: 1.9 $ $Date: 2004/07/22 02:34:25 $
See Also:
  Serialized Form

Field Summary
`(package private) static long` | `serialVersionUID` Serializable version identifier

Constructor Summary
`PolynomialSplineFunction(double[] knots, PolynomialFunction[] polynomials)` Construct a polynomial spline function with the given segment delimiters and interpolating polynomials.

Method Summary
`UnivariateRealFunction` | `derivative()` Returns the derivative of the polynomial spline function as a UnivariateRealFunction
`double[]` | `getKnots()` Returns an array copy of the knot points.
`int` | `getN()` Returns the number of spline segments = the number of polynomials = the number of knot points - 1.
`PolynomialFunction[]` | `getPolynomials()` Returns a copy of the interpolating polynomials array.
`PolynomialSplineFunction` | `polynomialSplineDerivative()` Returns the derivative of the polynomial spline function as a PolynomialSplineFunction
`double` | `value(double v)` Compute the value for the function.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### serialVersionUID

    static final long serialVersionUID

  Serializable version identifier

  See Also:
    Constant Field Values

Constructor Detail

### PolynomialSplineFunction

    public PolynomialSplineFunction(double[] knots,
                                    PolynomialFunction[] polynomials)

  Construct a polynomial spline function with the given segment delimiters and interpolating polynomials.

  The constructor copies both arrays and assigns the copies to the knots and polynomials properties, respectively.

Parameters:
  `knots` - spline segment interval delimiters
  `polynomials` - polynomial functions that make up the spline
Throws:
  `NullPointerException` - if either of the input arrays is null
  `IllegalArgumentException` - if knots has length less than 2, `polynomials.length != knots.length - 1` , or the knots array is not strictly increasing.

Method Detail

### value

    public double value(double v)
                 throws FunctionEvaluationException

  Compute the value for the function.

  Throws FunctionEvaluationException if v is outside of the domain of the function. The domain is [smallest knot, largest knot).

  See `PolynomialSplineFunction` for details on the algorithm for computing the value of the function.

  Specified by:
    `value` in interface `UnivariateRealFunction`
  Parameters:
    `v` - the point for which the function value should be computed
  Returns:
    the value
  Throws:
    `FunctionEvaluationException` - if v is outside of the domain of of the spline function (less than the smallest knot point or greater than or equal to the largest knot point)

### derivative

    public UnivariateRealFunction derivative()

  Returns the derivative of the polynomial spline function as a UnivariateRealFunction

  Returns:
    the derivative function

### polynomialSplineDerivative

    public PolynomialSplineFunction polynomialSplineDerivative()

  Returns the derivative of the polynomial spline function as a PolynomialSplineFunction

  Returns:
    the derivative function

### getN

    public int getN()

  Returns the number of spline segments = the number of polynomials = the number of knot points - 1.

  Returns:
    the number of spline segments

### getPolynomials

    public PolynomialFunction[] getPolynomials()

  Returns a copy of the interpolating polynomials array.

  Returns a fresh copy of the array. Changes made to the copy will not affect the polynomials property.

  Returns:
    the interpolating polynomials

### getKnots

    public double[] getKnots()

  Returns an array copy of the knot points.

  Returns a fresh copy of the array. Changes made to the copy will not affect the knots property.

  Returns:
    the knot points

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2003-2004 The Apache Software Foundation. All Rights Reserved.